#include <stdio.h>
#include <stdlib.h>
#include "fnlist.h"

struct function functions[] = {
   {"0xSec",f_0xSec, inv, 1, "Hex dump of section X (0..8)", 400},
   {"bitmap",f_bitmap, inv, 0, "bitmap mode", 700},
   {"center",f_center, inv, 0, "center", 110},
   {"code_table_0.0",f_code_table_0_0, inv, 0, "code table 0.0 discipline", -1},
   {"code_table_1.0",f_code_table_1_0, inv, 0, "code table 1.0 master table version", -1},
   {"code_table_1.1",f_code_table_1_1, inv, 0, "code table 1.1 local table version", -1},
   {"code_table_1.2",f_code_table_1_2, inv, 0, "code table 1.2 significance of reference time", -1},
   {"code_table_1.3",f_code_table_1_3, inv, 0, "code table 1.3 production status of processed data", -1},
   {"code_table_1.4",f_code_table_1_4, inv, 0, "code table 1.4 type of processed data", -1},
   {"code_table_3.0",f_code_table_3_0, inv, 0, "code table 3.0 Source of grid definition", -1},
   {"code_table_3.1",f_code_table_3_1, inv, 0, "code table 3.1 Grid definition template number", -1},
   {"code_table_3.11",f_code_table_3_11, inv, 0, "code table 3.11 regional/global thinned/reduced grid", -1},
   {"code_table_3.15",f_code_table_3_15, inv, 0, "code table 3.15 Physical meaning of vertical coordinate", -1},
   {"code_table_3.2",f_code_table_3_2, inv, 0, "code table 3.2 Size and Shape of Earth", -1},
   {"code_table_3.21",f_code_table_3_21, inv, 0, "code table 3.21 Vertical Dimension coordinate values defn", -1},
   {"code_table_3.6",f_code_table_3_6, inv, 0, "code table 3.6 Spectral data representation type", -1},
   {"code_table_3.7",f_code_table_3_7, inv, 0, "code table 3.7 Spectral data representation mode", -1},
   {"code_table_3.8",f_code_table_3_8, inv, 0, "code table 3.8 Grid point position", -1},
   {"code_table_4.0",f_code_table_4_0, inv, 0, "code table 4.0 Product Definition Template Number", -1},
   {"code_table_4.1",f_code_table_4_1, inv, 0, "code table 4.1", -1},
   {"code_table_4.10",f_code_table_4_10, inv, 0, "code table 4.10 statistical processing", -1},
   {"code_table_4.2",f_code_table_4_2, inv, 0, "code table 4.2", -1},
   {"code_table_4.3",f_code_table_4_3, inv, 0, "code table 4.3 Type of Generating Process", -1},
   {"code_table_4.4",f_code_table_4_4, inv, 0, "code table 4.4", -1},
   {"code_table_4.5a",f_code_table_4_5a, inv, 0, "code table 4.5 (1st value)", -1},
   {"code_table_4.5b",f_code_table_4_5b, inv, 0, "code table 4.5 (2nd value)", -1},
   {"code_table_4.6",f_code_table_4_6, inv, 0, "code table 4.6 ensemble type", -1},
   {"code_table_4.7",f_code_table_4_7, inv, 0, "code table 4.7 derived forecast", -1},
   {"code_table_4.9",f_code_table_4_9, inv, 0, "code table 4.9 Probability Type", -1},
   {"code_table_5.0",f_code_table_5_0, inv, 0, "code table 5.0 data representation number", -1},
   {"code_table_5.1",f_code_table_5_1, inv, 0, "code table 5.1 type of original field values", -1},
   {"code_table_5.5",f_code_table_5_5, inv, 0, "code table 5.5 missing value management for complex packing", -1},
   {"code_table_5.7",f_code_table_5_7, inv, 0, "code table 5.7 precision in IEEE packing", -1},
   {"code_table_6.0",f_code_table_6_0, inv, 0, "code table 6.0 Bitmap indicator", -1},
   {"ctl_inv",f_ctl_inv, inv, 0, "ctl inventory dump (for g2ctl)", 100},
   {"disc",f_code_table_0_0, inv, 0, "discipline (code table 0.0)", 200},
   {"domain",f_domain, inv, 0, "max limit for n/s/e/w", 100},
   {"ens",f_ens, inv, 0, "ensemble information", 200},
   {"flag_table_3.10",f_flag_table_3_10, inv, 0, "flag table 3.10 scanning mode for one diamond", -1},
   {"flag_table_3.3",f_flag_table_3_3, inv, 0, "flag table 3.3, resolution and component flags", -1},
   {"flag_table_3.4",f_flag_table_3_4, inv, 0, "flag table 3.4, scanning mode", -1},
   {"flag_table_3.5",f_flag_table_3_5, inv, 0, "flag table 3.5 projection center", -1},
   {"flag_table_3.9",f_flag_table_3_9, inv, 0, "flag table 3.9 numbering order of diamonds seen from corresponding pole", -1},
   {"ftime",f_ftime, inv, 0, "forecast time", 440},
   {"grid",f_grid, inv, 0, "grid definition", 200},
   {"ij",f_ij, inv, 2, "value of field at grid(X,Y) X=1,..,nx Y=1,..,ny", 100},
   {"ijlat",f_ijlat, inv, 2, "lat,lon and grid value at grid(X,Y) X=1,..,nx Y=1,..,ny", 100},
   {"ilat",f_ilat, inv, 1, "lat,lon and grid value at Xth grid point, X=1,..,npnts", 100},
   {"lev",f_lev, inv, 0, "level (code table 4.5)", 200},
   {"lev0",f_lev0, inv, 0, "level (for g2ctl)", 200},
   {"lon",f_lon, inv, 2, "value at grid point nearest lon=X lat=Y", 100},
   {"max",f_max, inv, 0, "print maximum value", 100},
   {"min",f_min, inv, 0, "print minimum value", 100},
   {"MM",f_MM, inv, 0, "month", 105},
   {"N_ens",f_N_ens, inv, 0, "number of ensemble members", 200},
   {"nl",f_nl, inv, 0, "inserts new line into inventory", 100},
   {"nlons",f_nlons, inv, 0, "number of longitudes for each latitude", 200},
   {"nl_out",f_nl_out, inv, 1, "write new line in file X", 100},
   {"npts",f_npts, inv, 0, "number of grid points", 500},
   {"nxny",f_nxny, inv, 0, "nx and ny of grid", 200},
   {"packing",f_packing, inv, 0, "data packing mode", 510},
   {"pds_fcst_time",f_pds_fcst_time, inv, 0, "fcst_time(1) in units given by pds", -1},
   {"print",f_print, inv, 1, "inserts string into inventory", 100},
   {"process",f_code_table_4_3, inv, 0, "Process (code table 4.3)", 200},
   {"processid",f_processid, inv, 0, "process id (locally defined)", 400},
   {"range",f_range, inv, 0, "print out location of record in bytes, 0 = first byte", 100},
   {"RT",f_RT, inv, 0, "Reference Time", 110},
   {"s",f_s, inv, 0, "simple inventory", 100},
   {"scan",f_scan, inv, 0, "scan order of grid", 200},
   {"Sec0",f_Sec0, inv, 0, "contents of section0", 200},
   {"Sec3",f_Sec3, inv, 0, "contents of section 3 (Grid Definition Section)", 200},
   {"Sec4",f_Sec4, inv, 0, "Sec 4 values (Product definition section)", 400},
   {"Sec5",f_Sec5, inv, 0, "Sec 5 values (Data representation section)", 400},
   {"Sec6",f_Sec6, inv, 0, "show bit-map section", 700},
   {"Sec_len",f_Sec_len, inv, 0, "length of various grib sections", 700},
   {"stats",f_stats, inv, 0, "statistical summary of data values", 100},
   {"subcenter",f_subcenter, inv, 0, "subcenter", 110},
   {"t",f_t, inv, 0, "time YYYYMMDDHH, -v2 for alt format", 100},
   {"T",f_T, inv, 0, "time YYYYMMDDHHMMSS", 101},
   {"table",f_table, inv, 0, "parameter table", 200},
   {"V",f_V, inv, 0, "diagnostic output", 100},
   {"var",f_var, inv, 0, "short variable name", 400},
   {"varX",f_varX, inv, 0, "raw variable name - discipline mastertab localtab center parmcat parmnum", 400},
   {"vector_dir",f_vector_dir, inv, 0, "grid or earth relative winds", 1},
   {"verf",f_verf, inv, 0, "simple inventory using verification time", 100},
   {"vt",f_vt, inv, 0, "verf time = reference_time + forecast_time, -v2 for alt format", 400},
   {"VT",f_VT, inv, 0, "verf time = reference_time + forecast_time (YYYYMMDDHHMMSS)", 400},
   {"YY",f_YY, inv, 0, "year", 103},
   {"s_out",f_s_out, inv_output, 1, "simple inventory written to X", 100},
   {"colon",f_colon, misc, 1, "replace item deliminator (:) with X", 100},
   {"end",f_end, misc, 0, "stop after first (sub)message (save time)", 100},
   {"grib_bits",f_grib_bits, misc, 1, "X set number of binary bits for grib_out packing", 100},
   {"grid_def",f_grid_def, misc, 0, "read lon and lat data from grib file -- experimental", 100},
   {"h",f_h, misc, 0, "help, shows common options", 100},
   {"header",f_header, misc, 0, "f77 header or nx-ny header in text output (default)", 100},
   {"help",f_help, misc, 1, "help [search string|all], -help all, shows all options", 100},
   {"if",f_if, misc, 1, "if X (regular expression) matches, do next out option", 100},
   {"ijundefine",f_ijundefine, misc, 3, "sets grid point values to undefined X=(in-box|out-box) Y=ix0:ix1 Z=iy0:iy1", 100},
   {"inv",f_inv, misc, 1, "write inventory to X", 100},
   {"limit",f_limit, misc, 1, "stops after X fields decoded", 100},
   {"no_header",f_no_header, misc, 0, "no f77 header or nx-ny header in text output", 100},
   {"not_if",f_not_if, misc, 1, "if not X (regular expression) matches, do next out option", 100},
   {"one_line",f_one_line, misc, 0, "puts all on one line (makes into inventory format)", 100},
   {"quit",f_end, misc, 0, "stop after first (sub)message (save time)", -1},
   {"submsg",f_submsg, misc, 1, "process submessage X (0=process all messages)", 100},
   {"text_col",f_text_col, misc, 1, "number of columns on text output", 100},
   {"text_fmt",f_text_fmt, misc, 1, "format for text output (C)", 100},
   {"undefine",f_undefine, misc, 3, "sets grid point values to undefined X=(in-box|out-box) Y=lon0:lon1 Z=lat0:lat1", 100},
   {"undefine_val",f_undefine_val, misc, 1, "grid point set to undefined if X=val or X=low:high", 100},
   {"v",f_v, misc, 0, "verbose (v=1)", 100},
   {"v0",f_v0, misc, 0, "not verbose (v=0)", 100},
   {"v1",f_v, misc, 0, "verbose (v=1)", -1},
   {"v2",f_v2, misc, 0, "really verbose (v=2)", 100},
   {"version",f_version, misc, 0, "print version", 100},
   {"bin",f_bin, output, 1, "write binary data to X", 100},
   {"grib",f_grib, output, 1, "writes GRIB record (one submessage) to X", 100},
   {"GRIB",f_GRIB, output, 1, "writes entire GRIB record (all submessages)", 100},
   {"grib_ieee",f_grib_ieee, output, 1, "writes decoded/modified data in grib-2 format to file X", 100},
   {"grib_out",f_grib_out, output, 1, "writes decoded/modified data in grib-2 format to file X", 100},
   {"ieee",f_ieee, output, 1, "write big-endian IEEE data to X", 100},
   {"ijbox",f_ijbox, output, 4, "grid values in bounding box X=i1:i2[:di] Y=j1:j2[:dj] Z=file A=[bin|text|spread]", 100},
   {"lola",f_lola, output, 4, "lon-lat grid values X=lon0:nlon:dlon Y=lat0:nlat:dlat Z=file A=[bin|text|spread]", 100},
   {"netcdf",f_netcdf, output, 1, "write netcdf data to X", 100},
   {"spread",f_spread, output, 1, "write text - spread sheet format into X", 100},
   {"text",f_text, output, 1, "write text data into X", 100},
   {"append",f_append, setup, 0, "append mode, write to existing output files", 100},
   {"d",f_d, setup, 1, "dump message X (n or n.m)", 200},
   {"flush",f_flush, setup, 0, "flush output buffers after every write (interactive)", -1},
   {"i",f_i, setup, 0, "read Inventory from stdin", 100},
   {"match",f_match, setup, 1, "process data that matches X (regular expression)", 100},
   {"nc_grads",f_nc_grads, setup, 0, "require netcdf file to be grads v1.9b4 compatible (fixed time step only)", 100},
   {"nc_nlev",f_nc_nlev, setup, 1, "netcdf, X = max LEV dimension for {TIME,LEV,LAT,LON} data", 100},
   {"nc_pack",f_nc_pack, setup, 1, "pack/check limits of all NEW input variables, X=min:max[:byte|short|float]", 100},
   {"nc_table",f_nc_table, setup, 1, "X is conversion_to_netcdf_table file name", 100},
   {"nc_time",f_nc_time, setup, 1, "netcdf, [[-]yyyymmddhhnnss]:[dt{s[ec]|m[in]|h[our]|d[ay]}], [-] is for time alignment only", 100},
   {"no_append",f_no_append, setup, 0, "not append mode, write to new output files (default)", 100},
   {"no_flush",f_no_flush, setup, 0, "flush output buffers when full (default)", -1},
   {"no_nc_grads",f_no_nc_grads, setup, 0, "netcdf file may be not grads v1.9b4 compatible, variable time step", 100},
   {"no_nc_pack",f_no_nc_pack, setup, 0, "no packing in netcdf for NEW variables", 100},
   {"no_nc_table",f_no_nc_table, setup, 0, "disable previously defined conversion_to_netcdf_table", 100},
   {"no_nc_time",f_no_nc_time, setup, 0, "netcdf, disable previously defined initial or relative date and time step", 100},
   {"not",f_not, setup, 1, "process data that does not match X (regular expression)", 100},
   {"order",f_order, setup, 1, "decoded data in X (raw|we:sn|we:ns) order, we:sn is default", 200},
   {"tigge",f_tigge, setup, 0, "use modified-TIGGE grib table", 100},
};
 
int nfunctions = sizeof functions / sizeof functions[0];
