/* unpack grib_ieee format
 * 3/2008 public domain Wesley Ebisuzaki
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

#include "wgrib2.h"
#include "grb2.h"


/*
 * input:  sec[]
 *         float data[npnts]
 *
 */

int unpk_grib(unsigned char **sec, float *data) {

    int i, packing, ndata, bitmap_flag;
    unsigned char *mask_pointer, mask;
    unsigned char *ieee;

    packing = code_table_5_0(sec);
    ndata = GB2_Sec3_npts(sec);
    bitmap_flag = code_table_6_0(sec);
    if (packing == 4) {
        printf("codetable 5.0 is %d ndata=%d\n",packing,ndata);
        if (sec[5][11] != 1) fatal_error_i("unpk ieee grib file precision %d not supported", (int) sec[5][11]);

        // ieee depacking -- simple no bitmap etc testing
        if (bitmap_flag == 255) {
            for (i = 0; i < ndata; i++) {
                data[i] = ieee2flt_nan(sec[7]+5+i*4);
//                data[i] = ieee2flt(sec[7]+5+i*4);
            }
	    return 0;
        }
        if (bitmap_flag == 0 || bitmap_flag == 254) {
	    mask_pointer = sec[6] + 6;
	    ieee = sec[7]+5;
	    mask = 0;
	    for (i = 0; i < ndata; i++) {
		if ((i & 7) == 0) mask = *mask_pointer++;
		if (mask & 128) {
		    data[i] = ieee2flt_nan(ieee);
//		    data[i] = ieee2flt(ieee);
		     ieee += 4;
		}
		else {
		    data[i] = UNDEFINED;
		}
		mask <<= 1;
	    }
	    return 0;
	}
    }
    fatal_error_i("packing type %d not supported", packing);
    return 1;
}
